import React from 'react';
import ButtonGroup from '../ButtonGroup';
import OverflowMenuItem from '../OverflowMenuItem';
import OverflowMenu from '../OverflowMenu';
import Button from '../Button';
import { mount } from 'enzyme';
describe('SplitButton', function () {
  describe('renders as expected', function () {
    var wrapper = mount(React.createElement(ButtonGroup, {
      buttonLabel: 'Button Label'
    }, React.createElement(OverflowMenuItem, {
      itemText: 'Item 1',
      primaryFocus: true
    }), React.createElement(OverflowMenuItem, {
      itemText: 'Item 2'
    }), React.createElement(OverflowMenuItem, {
      itemText: 'Item 2'
    })));
    it('displays the correct menu text', function () {
      expect(wrapper.find(Button).props().children).toEqual('Button Label');
    });
    it('renders all children as expected', function () {
      var menu = wrapper.find(OverflowMenu);
      menu.simulate('click');
      expect(wrapper.find('FloatingMenu ul').props().children.length).toEqual(3);
    });
  });
});