/* eslint-disable no-console */
import React from 'react';
import { storiesOf } from '@storybook/react';
import { action } from '@storybook/addon-actions';
import { withKnobs, text } from '@storybook/addon-knobs';
import OverflowMenu from '../OverflowMenu';
import OverflowMenuItem from '../OverflowMenuItem';
import Button from '../Button';
import Link from '../Link';
import Card from './Card';
import CardFooter from '../CardFooter';
import CardContent from '../CardContent';
import CardContentItem from '../CardContentItem';
var readmeURL = 'https://bit.ly/2Z9PGsC';
var props = {
  default: function _default() {
    return {
      onClick: action('onClick'),
      onFocus: action('onFocus'),
      className: text('class name', 'some-class'),
      // iconName: text('icon name', 'Add16'),
      description: text('description', 'description')
    };
  }
};
storiesOf('Card', module).addDecorator(withKnobs).add('card', function () {
  return React.createElement(Card, props.default(), React.createElement(CardContent, {
    cardTitle: "Card Name",
    cardInfo: ['Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor'],
    cardLink: [React.createElement("a", {
      href: "#",
      class: "bx--link bx--card-footer__link"
    }, "Link")]
  }, React.createElement(OverflowMenu, null, React.createElement(OverflowMenuItem, {
    itemText: "Stop App"
  }), React.createElement(OverflowMenuItem, {
    itemText: "Restart App"
  }), React.createElement(OverflowMenuItem, {
    itemText: "Rename App"
  }), React.createElement(OverflowMenuItem, {
    itemText: "Delete App",
    hasDivider: true
  }))), React.createElement(CardFooter, null, React.createElement(Button, {
    size: "small",
    kind: "primary",
    style: {
      width: 10 + '%'
    }
  }, "Button"), React.createElement(Link, {
    href: "#",
    className: "bx--card-footer__link"
  }, "Link")));
}, {
  info: {
    /* eslint-disable no-useless-escape */
    text: "\n        Cards provide an at-a glance preview of the content they link to and frequently contain\n        easily-consumable content. The example below shows an empty card. Create Card Content, Card Footer,\n        Card Status and Card Actions components to add content to your card.\n          You can find more detailed information surrounding usage of this component\n          at the following url: ".concat(readmeURL, "\n        ")
    /* eslint-enable no-useless-escape */

  }
}).add('card with custom items', function () {
  return React.createElement(Card, props.default(), React.createElement(CardContent, {
    cardTitle: "Card Name",
    cardInfo: ['Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor'],
    cardLink: [React.createElement("a", {
      href: "#",
      class: "bx--link bx--card-footer__link"
    }, "Link")],
    cardContentItems: [React.createElement(CardContentItem, {
      info: 'Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor',
      maxWidth: '10rem'
    })]
  }, React.createElement(OverflowMenu, null, React.createElement(OverflowMenuItem, {
    itemText: "Stop App"
  }), React.createElement(OverflowMenuItem, {
    itemText: "Restart App"
  }), React.createElement(OverflowMenuItem, {
    itemText: "Rename App"
  }), React.createElement(OverflowMenuItem, {
    itemText: "Delete App",
    hasDivider: true
  }))), React.createElement(CardFooter, null, React.createElement(Button, {
    size: "small",
    kind: "primary",
    style: {
      width: 10 + '%'
    }
  }, "Button"), React.createElement(Link, {
    href: "#",
    className: "bx--card-footer__link"
  }, "Link")));
}, {
  info: {
    /* eslint-disable no-useless-escape */
    text: "\n        Cards provide an at-a glance preview of the content they link to and frequently contain\n        easily-consumable content. The example below shows an empty card. Create Card Content, Card Footer,\n        Card Status and Card Actions components to add content to your card.\n          You can find more detailed information surrounding usage of this component\n          at the following url: ".concat(readmeURL, "\n        ")
    /* eslint-enable no-useless-escape */

  }
});