function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import PropTypes from 'prop-types';
import React, { useEffect, useState, useRef } from 'react';
import TooltipDefiniton from '../TooltipDefinition';
import { settings } from '@rocketsoftware/carbon-components';
var prefix = settings.prefix;

var CardContentItem = function CardContentItem(_ref) {
  var info = _ref.info,
      cardContentRef = _ref.cardContentRef,
      maxWidth = _ref.maxWidth;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      overflowState = _useState2[0],
      setOverflowState = _useState2[1];

  var contentRef = useRef(null);
  useEffect(function () {
    if (cardContentRef !== undefined) {
      setOverflowState(contentRef.current.clientWidth > cardContentRef.current.clientWidth);
    }
  }, [cardContentRef]);
  return React.createElement("div", {
    ref: contentRef
  }, !overflowState && React.createElement("h4", {
    style: {
      whiteSpace: 'nowrap'
    },
    className: "".concat(prefix, "--about__title--additional-info")
  }, info), overflowState && React.createElement(TooltipDefiniton, {
    assistiveTextClassName: "".concat(prefix, "--assistive-text__overflow"),
    triggerClassName: "".concat(prefix, "--card-text__overflow"),
    direction: 'middle',
    tooltipText: info
  }, React.createElement("span", {
    className: "".concat(prefix, "--definition-text__span"),
    style: {
      maxWidth: maxWidth
    }
  }, info)));
};

CardContentItem.propTypes = {
  /**
   * String of information to be shown on a card
   */
  info: PropTypes.string,

  /**
   * Prop for ref which is passed to it by the CardContent component
   */
  cardContentRef: PropTypes.oneOfType([PropTypes.func, PropTypes.shape({
    current: PropTypes.any
  })]),

  /**
   * Specify max-width of item (should be no bigger than the intended width of card)
   */
  maxWidth: PropTypes.string
};
export default CardContentItem;