import React from 'react';
import Tour from '../Tour';
import TourTooltip from '../TourTooltip';
import { mount } from 'enzyme';
var description = 'Tooltip description for a tour step.';
var steps = {
  default: function _default() {
    return [{
      selector: null,
      description: description
    }];
  }
};
describe('Tour', function () {
  describe('renders as expected', function () {
    var wrapper = mount(React.createElement(Tour, {
      steps: steps.default()
    }));
    it('renders the tooltip', function () {
      expect(wrapper.find(TourTooltip).length).toEqual(1);
    });
    it('passes content to tooltip through steps', function () {
      var descRegExp = new RegExp(description);
      expect(descRegExp.test(wrapper.text())).toEqual(true);
    });
  });
});