"use strict";

var _react = _interopRequireDefault(require("react"));

var _ButtonGroup = _interopRequireDefault(require("../ButtonGroup"));

var _OverflowMenuItem = _interopRequireDefault(require("../OverflowMenuItem"));

var _OverflowMenu = _interopRequireDefault(require("../OverflowMenu"));

var _Button = _interopRequireDefault(require("../Button"));

var _enzyme = require("enzyme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('SplitButton', function () {
  describe('renders as expected', function () {
    var wrapper = (0, _enzyme.mount)(_react.default.createElement(_ButtonGroup.default, {
      buttonLabel: 'Button Label'
    }, _react.default.createElement(_OverflowMenuItem.default, {
      itemText: 'Item 1',
      primaryFocus: true
    }), _react.default.createElement(_OverflowMenuItem.default, {
      itemText: 'Item 2'
    }), _react.default.createElement(_OverflowMenuItem.default, {
      itemText: 'Item 2'
    })));
    it('displays the correct menu text', function () {
      expect(wrapper.find(_Button.default).props().children).toEqual('Button Label');
    });
    it('renders all children as expected', function () {
      var menu = wrapper.find(_OverflowMenu.default);
      menu.simulate('click');
      expect(wrapper.find('FloatingMenu ul').props().children.length).toEqual(3);
    });
  });
});