"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = _interopRequireDefault(require("../Button"));

var _OverflowMenu = _interopRequireDefault(require("../OverflowMenu"));

var _types = require("../../prop-types/types");

var _iconsReact = require("@rocketsoftware/icons-react");

var _carbonComponents = require("@rocketsoftware/carbon-components");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefix = _carbonComponents.settings.prefix;

var ButtonGroup = function ButtonGroup(_ref) {
  var children = _ref.children,
      buttonLabel = _ref.buttonLabel,
      disabled = _ref.disabled,
      size = _ref.size,
      kind = _ref.kind;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1];

  var buttonRef = (0, _react.useRef)(null);

  var getOffset = function getOffset() {
    var _buttonRef$current$ge = buttonRef.current.getBoundingClientRect(),
        top = _buttonRef$current$ge.top;

    return {
      top: top * -1,
      left: 'auto'
    };
  };

  var forOnOpen = function forOnOpen() {
    setIsOpen(true);
  };

  var forOnClose = function forOnClose() {
    setIsOpen(false);
  };

  var iconClasses = (0, _classnames.default)("".concat(prefix, "--btn-group-icon"), _defineProperty({}, "".concat(prefix, "--btn-group-icon__open"), isOpen));
  return _react.default.createElement("div", {
    "data-floating-menu-container": true,
    ref: buttonRef,
    className: "".concat(prefix, "--btn-group")
  }, _react.default.createElement(_OverflowMenu.default, {
    renderIcon: _react.default.forwardRef(function () {
      return _react.default.createElement(_Button.default, {
        className: iconClasses,
        renderIcon: _iconsReact.ChevronDown16,
        kind: kind,
        size: size,
        disabled: disabled
      }, buttonLabel);
    }),
    onOpen: forOnOpen,
    menuOptionsClass: "".concat(prefix, "--overflow-menu-options--container"),
    onClose: forOnClose,
    menuOffset: getOffset,
    disabled: disabled
  }, children));
};

ButtonGroup.propTypes = {
  /**
   * Specify button label
   */
  buttonLabel: _propTypes.default.string,

  /**
   * Specify button size
   */
  size: _propTypes.default.oneOf(['default', 'field', 'small']),

  /**
   * Specify button type
   */
  kind: _propTypes.default.oneOf(_types.ButtonKinds).isRequired
};
ButtonGroup.defaultProps = {
  kind: 'primary',
  size: 'default'
};
var _default = ButtonGroup;
exports.default = _default;