"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _TooltipDefinition = _interopRequireDefault(require("../TooltipDefinition"));

var _carbonComponents = require("@rocketsoftware/carbon-components");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefix = _carbonComponents.settings.prefix;

var CardContentItem = function CardContentItem(_ref) {
  var info = _ref.info,
      cardContentRef = _ref.cardContentRef,
      maxWidth = _ref.maxWidth;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      overflowState = _useState2[0],
      setOverflowState = _useState2[1];

  var contentRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (cardContentRef !== undefined) {
      setOverflowState(contentRef.current.clientWidth > cardContentRef.current.clientWidth);
    }
  }, [cardContentRef]);
  return _react.default.createElement("div", {
    ref: contentRef
  }, !overflowState && _react.default.createElement("h4", {
    style: {
      whiteSpace: 'nowrap'
    },
    className: "".concat(prefix, "--about__title--additional-info")
  }, info), overflowState && _react.default.createElement(_TooltipDefinition.default, {
    assistiveTextClassName: "".concat(prefix, "--assistive-text__overflow"),
    triggerClassName: "".concat(prefix, "--card-text__overflow"),
    direction: 'middle',
    tooltipText: info
  }, _react.default.createElement("span", {
    className: "".concat(prefix, "--definition-text__span"),
    style: {
      maxWidth: maxWidth
    }
  }, info)));
};

CardContentItem.propTypes = {
  /**
   * String of information to be shown on a card
   */
  info: _propTypes.default.string,

  /**
   * Prop for ref which is passed to it by the CardContent component
   */
  cardContentRef: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.shape({
    current: _propTypes.default.any
  })]),

  /**
   * Specify max-width of item (should be no bigger than the intended width of card)
   */
  maxWidth: _propTypes.default.string
};
var _default = CardContentItem;
exports.default = _default;