"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _addonKnobs = require("@storybook/addon-knobs");

var _addonActions = require("@storybook/addon-actions");

var _FooterWrapper = _interopRequireDefault(require("./FooterWrapper"));

var _Button = _interopRequireDefault(require("../Button"));

var _HeaderContainer = _interopRequireDefault(require("../UIShell/HeaderContainer"));

var _UIShell = require("../UIShell");

var _iconsReact = require("@rocketsoftware/icons-react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Fade16 = function Fade16() {
  return _react.default.createElement("svg", {
    width: "16",
    height: "16",
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 32 32",
    "aria-hidden": "true"
  }, _react.default.createElement("path", {
    d: "M8.24 25.14L7 26.67a14 14 0 0 0 4.18 2.44l.68-1.88a12 12 0 0 1-3.62-2.09zm-4.05-7.07l-2 .35A13.89 13.89 0 0 0 3.86 23l1.73-1a11.9 11.9 0 0 1-1.4-3.93zm7.63-13.31l-.68-1.88A14 14 0 0 0 7 5.33l1.24 1.53a12 12 0 0 1 3.58-2.1zM5.59 10L3.86 9a13.89 13.89 0 0 0-1.64 4.54l2 .35A11.9 11.9 0 0 1 5.59 10zM16 2v2a12 12 0 0 1 0 24v2a14 14 0 0 0 0-28z"
  }));
};

var StoryContent = function StoryContent() {
  var content = _react.default.createElement("div", {
    className: "bx--grid"
  }, _react.default.createElement("div", {
    className: "bx--row"
  }, _react.default.createElement("div", {
    className: "bx--col-lg-13"
  }, _react.default.createElement("h2", {
    style: {
      fontWeight: '800',
      margin: '30px 0',
      fontSize: '20px'
    }
  }, "Purpose and function"), _react.default.createElement("p", {
    style: {
      lineHeight: '20px'
    }
  }, "The shell is perhaps the most crucial piece of any UI built with Carbon. It contains the shared navigation framework for the entire design system and ties the products in IBM\u2019s portfolio together in a cohesive and elegant way. The shell is the home of the topmost navigation, where users can quickly and dependably gain their bearings and move between pages.", _react.default.createElement("br", null), _react.default.createElement("br", null), "The shell was designed with maximum flexibility built in, to serve the needs of a broad range of products and users. Adopting the shell ensures compliance with IBM design standards, simplifies development efforts, and provides great user experiences. All IBM products built with Carbon are required to use the shell\u2019s header.", _react.default.createElement("br", null), _react.default.createElement("br", null), "To better understand the purpose and function of the UI shell, consider the \u201Cshell\u201D of MacOS, which contains the Apple menu, top-level navigation, and universal, OS-level controls at the top of the screen, as well as a universal dock along the bottom or side of the screen. The Carbon UI shell is roughly analogous in function to these parts of the Mac UI. For example, the app switcher portion of the shell can be compared to the dock in MacOS."), _react.default.createElement("h2", {
    style: {
      fontWeight: '800',
      margin: '30px 0',
      fontSize: '20px'
    }
  }, "Header responsive behavior"), _react.default.createElement("p", {
    style: {
      lineHeight: '20px'
    }
  }, "As a header scales down to fit smaller screen sizes, headers with persistent side nav menus should have the side nav collapse into \u201Chamburger\u201D menu. See the example to better understand responsive behavior of the header."), _react.default.createElement("h2", {
    style: {
      fontWeight: '800',
      margin: '30px 0',
      fontSize: '20px'
    }
  }, "Secondary navigation"), _react.default.createElement("p", {
    style: {
      lineHeight: '20px'
    }
  }, "The side-nav contains secondary navigation and fits below the header. It can be configured to be either fixed-width or flexible, with only one level of nested items allowed. Both links and category lists can be used in the side-nav and may be mixed together. There are several configurations of the side-nav, but only one configuration should be used per product section. If tabs are needed on a page when using a side-nav, then the tabs are secondary in hierarchy to the side-nav.", _react.default.createElement("br", null), _react.default.createElement("br", null), "If you are using side-nav alongside the header and header-container as well as specifying the defaultExpanded prop, globalExpand is then required."))));

  return _react.default.createElement(_UIShell.Content, {
    id: "main-content",
    style: {
      padding: 0
    }
  }, content);
};

var props = function props() {
  return {
    id: (0, _addonKnobs.text)('Dropdown ID (id)', 'carbon-dropdown-example'),
    inZowe: (0, _addonKnobs.boolean)('In Zowe', false),
    className: (0, _addonKnobs.text)('Classname', 'classname')
  };
};

(0, _react2.storiesOf)('FooterWrapper', module).addDecorator(_addonKnobs.withKnobs).add('default', function () {
  return _react.default.createElement("div", {
    style: {
      width: 200 + 'vh'
    }
  }, _react.default.createElement(_FooterWrapper.default, props(), _react.default.createElement(_Button.default, {
    kind: "secondary"
  }, "Button"), _react.default.createElement(_Button.default, {
    kind: "primary"
  }, "Button")));
}, {
  info: {
    text: 'Placeholder'
  }
}).add('SideNav Rail w/Header', function () {
  return _react.default.createElement(_HeaderContainer.default, {
    render: function render(_ref) {
      var isSideNavExpanded = _ref.isSideNavExpanded,
          onClickSideNavExpand = _ref.onClickSideNavExpand;
      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_UIShell.Header, {
        "aria-label": "IBM Platform Name"
      }, _react.default.createElement(_UIShell.SkipToContent, null), _react.default.createElement(_UIShell.HeaderMenuButton, {
        "aria-label": "Open menu",
        isCollapsible: true,
        onClick: onClickSideNavExpand,
        isActive: isSideNavExpanded
      }), _react.default.createElement(_UIShell.HeaderName, {
        href: "#",
        prefix: "IBM"
      }, "[Platform]"), _react.default.createElement(_UIShell.HeaderNavigation, {
        "aria-label": "IBM [Platform]"
      }, _react.default.createElement(_UIShell.HeaderMenuItem, {
        href: "#"
      }, "Link 1"), _react.default.createElement(_UIShell.HeaderMenuItem, {
        href: "#"
      }, "Link 2"), _react.default.createElement(_UIShell.HeaderMenuItem, {
        href: "#"
      }, "Link 3"), _react.default.createElement(_UIShell.HeaderMenu, {
        "aria-label": "Link 4"
      }, _react.default.createElement(_UIShell.HeaderMenuItem, {
        href: "#"
      }, "Sub-link 1"), _react.default.createElement(_UIShell.HeaderMenuItem, {
        href: "#"
      }, "Sub-link 2"), _react.default.createElement(_UIShell.HeaderMenuItem, {
        href: "#"
      }, "Sub-link 3"))), _react.default.createElement(_UIShell.HeaderGlobalBar, null, _react.default.createElement(_UIShell.HeaderGlobalAction, {
        "aria-label": "Search",
        onClick: (0, _addonActions.action)('search click')
      }, _react.default.createElement(_iconsReact.Search20, null)), _react.default.createElement(_UIShell.HeaderGlobalAction, {
        "aria-label": "Notifications",
        onClick: (0, _addonActions.action)('notification click')
      }, _react.default.createElement(_iconsReact.Notification20, null)), _react.default.createElement(_UIShell.HeaderGlobalAction, {
        "aria-label": "App Switcher",
        onClick: (0, _addonActions.action)('app-switcher click')
      }, _react.default.createElement(_iconsReact.AppSwitcher20, null)))), _react.default.createElement(_UIShell.SideNav, {
        "aria-label": "Side navigation",
        isRail: true,
        expanded: isSideNavExpanded
      }, _react.default.createElement(_UIShell.SideNavItems, null, _react.default.createElement(_UIShell.SideNavMenu, {
        renderIcon: Fade16,
        title: "Category title"
      }, _react.default.createElement(_UIShell.SideNavMenuItem, {
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavMenuItem, {
        isActive: true,
        "aria-current": "page",
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavMenuItem, {
        href: "javascript:void(0)"
      }, "Link")), _react.default.createElement(_UIShell.SideNavMenu, {
        renderIcon: Fade16,
        title: "Category title"
      }, _react.default.createElement(_UIShell.SideNavMenuItem, {
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavMenuItem, {
        "aria-current": "page",
        isActive: true,
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavMenuItem, {
        href: "javascript:void(0)"
      }, "Link")), _react.default.createElement(_UIShell.SideNavMenu, {
        renderIcon: Fade16,
        title: "Category title"
      }, _react.default.createElement(_UIShell.SideNavMenuItem, {
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavMenuItem, {
        isActive: true,
        "aria-current": "page",
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavMenuItem, {
        href: "javascript:void(0)"
      }, "Link")), _react.default.createElement(_UIShell.SideNavLink, {
        renderIcon: Fade16,
        href: "javascript:void(0)"
      }, "Link"), _react.default.createElement(_UIShell.SideNavLink, {
        renderIcon: Fade16,
        href: "javascript:void(0)"
      }, "Link"))), _react.default.createElement(StoryContent, null), _react.default.createElement(_FooterWrapper.default, props, _react.default.createElement("div", {
        style: {
          textAlign: 'right'
        }
      }, _react.default.createElement(_Button.default, {
        kind: "secondary"
      }, "Button"), _react.default.createElement(_Button.default, {
        style: {
          marginLeft: 1 + 'rem'
        },
        kind: "primary"
      }, "Button"))));
    }
  });
});