"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _carbonComponents = require("@rocketsoftware/carbon-components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var prefix = _carbonComponents.settings.prefix;

var FooterWrapper = function FooterWrapper(_ref) {
  var _cx;

  var children = _ref.children,
      className = _ref.className,
      inZowe = _ref.inZowe,
      id = _ref.id;
  var wrapperClasses = (0, _classnames.default)((_cx = {}, _defineProperty(_cx, "".concat(prefix, "--footer-wrapper"), true), _defineProperty(_cx, "in-zowe", inZowe), _defineProperty(_cx, className, className), _cx));
  return _react.default.createElement("div", {
    className: wrapperClasses,
    id: id
  }, children);
};

FooterWrapper.propTypes = {
  /**
   * Specify an id for the wrapper
   */
  id: _propTypes.default.string,

  /**
   * Provide nodes to be rendered within the wrapper
   */
  children: _propTypes.default.node,

  /**
   * Provide an optional class to be added to the wrapper
   */
  className: _propTypes.default.string,

  /**
   * Specify whether the footer will be used in Zowe
   */
  inZowe: _propTypes.default.bool
};
FooterWrapper.defaultProps = {
  inZowe: true
};
var _default = FooterWrapper;
exports.default = _default;