"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _carbonComponents = require("@rocketsoftware/carbon-components");

var _Button = _interopRequireDefault(require("../Button"));

var _OverflowMenu = _interopRequireDefault(require("../OverflowMenu"));

var _iconsReact = require("@rocketsoftware/icons-react");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var prefix = _carbonComponents.settings.prefix;

var SplitButton = function SplitButton(_ref) {
  var _cx;

  var classNameContainer = _ref.classNameContainer,
      classNameButton = _ref.classNameButton,
      classNameOverflow = _ref.classNameOverflow,
      disabled = _ref.disabled,
      size = _ref.size,
      tabIndex = _ref.tabIndex,
      type = _ref.type,
      role = _ref.role,
      children = _ref.children,
      getViewport = _ref.getViewport,
      other = _objectWithoutProperties(_ref, ["classNameContainer", "classNameButton", "classNameOverflow", "disabled", "size", "tabIndex", "type", "role", "children", "getViewport"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1];

  var buttonRef = (0, _react.useRef)(null);

  var getOffset = function getOffset() {
    var _buttonRef$current$ge = buttonRef.current.getBoundingClientRect(),
        top = _buttonRef$current$ge.top;

    return {
      top: top * -1,
      left: 'auto'
    };
  };

  var childrenArray = _react.default.Children.toArray(children);

  var primaryAction = childrenArray.splice(0, 1)[0].props;
  var primaryButtonProps = {
    onClick: primaryAction.onClick,
    text: primaryAction.itemText
  };

  var forOnOpen = function forOnOpen() {
    setIsOpen(true);
  };

  var forOnClose = function forOnClose() {
    setIsOpen(false);
  };

  var containerClasses = (0, _classnames.default)(classNameContainer, "".concat(prefix, "--btn--split--container"));
  var overflowClasses = (0, _classnames.default)(classNameOverflow, (_cx = {}, _defineProperty(_cx, "".concat(prefix, "--btn--split--overflow--field"), size === 'field'), _defineProperty(_cx, "".concat(prefix, "--btn--split--overflow--sm"), size === 'small'), _defineProperty(_cx, "".concat(prefix, "--btn--split--overflow"), true), _defineProperty(_cx, "".concat(prefix, "--btn--split--overflow--disabled"), disabled), _cx));
  var overflowIconClasses = (0, _classnames.default)("".concat(prefix, "--btn--split--overflow--icon"), _defineProperty({}, "".concat(prefix, "--btn--split--overflow__open"), isOpen));
  return _react.default.createElement("div", _extends({
    className: containerClasses,
    tabIndex: tabIndex,
    ref: buttonRef
  }, other, {
    "data-floating-menu-container": true
  }), _react.default.createElement(_Button.default, _extends({
    type: type,
    role: role,
    disabled: disabled,
    className: classNameButton,
    size: size
  }, primaryButtonProps), primaryButtonProps.text), _react.default.createElement(_OverflowMenu.default, {
    className: overflowClasses,
    disabled: disabled,
    onOpen: forOnOpen,
    onClose: forOnClose,
    iconClass: overflowIconClasses,
    menuOptionsClass: "".concat(prefix, "--overflow-menu-options--container"),
    renderIcon: _iconsReact.ChevronDown16,
    menuOffset: getOffset,
    getViewport: getViewport
  }, childrenArray));
};

SplitButton.propTypes = {
  /**
   * Container classes
   */
  classNameContainer: _propTypes.default.string,

  /**
   * Add an optional class to the button
   */
  classNameButton: _propTypes.default.string,

  /**
   * Add an optional class to the button
   */
  classNameOverflow: _propTypes.default.string,

  /**
   * Child nodes to be rendered in secondary actions menu
   */
  children: _propTypes.default.node.isRequired,

  /**
   * For specifying whether the button is disabled
   */
  disabled: _propTypes.default.bool,

  /**
   * For specifying size of split button
   */
  size: _propTypes.default.oneOf(['default', 'field', 'small']),

  /**
   * Optional prop to specify the tabIndex of the SplitButton
   */
  tabIndex: _propTypes.default.number,

  /**
   * Optional prop to specify the type of the Primary Button
   */
  type: _propTypes.default.oneOf(['button', 'reset', 'submit']),

  /**
   * Optional prop to specify the role of the Primary Button
   */
  role: _propTypes.default.string,

  /**
   * Optional callback used to obtain a custom 'viewport' that differs from the window.
   */
  getViewport: _propTypes.default.func
};
SplitButton.defaultProps = {
  tabIndex: 0,
  type: 'button',
  disabled: false
};
var _default = SplitButton;
exports.default = _default;