"use strict";

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _TourTooltip = _interopRequireDefault(require("../TourTooltip"));

var _react2 = require("@storybook/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var props = {
  default: function _default() {
    return {
      title: 'Tooltip Title: Text',
      description: "Lorem ipsum dolor sit amet, \n    consectetur adipiscing elit, \n    sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
      onNext: function onNext() {
        return alert('next');
      },
      onPrev: function onPrev() {
        return alert('prev');
      },
      onClose: function onClose() {
        return alert('close');
      }
    };
  }
};
(0, _react2.storiesOf)('Pattern|TourTooltip', module).addDecorator(_addonKnobs.withKnobs).add('default', function () {
  return _react.default.createElement(_TourTooltip.default, props.default());
}).add('custom labels', function () {
  return _react.default.createElement(_TourTooltip.default, _extends({}, props.default(), {
    nextLabel: 'Next Page',
    closeLabel: 'End Tour',
    prevLabel: 'Back'
  }));
}).add('hidden inputs', function () {
  return _react.default.createElement(_TourTooltip.default, _extends({}, props.default(), {
    nextLabel: (0, _addonKnobs.text)('Next label', 'Next Page'),
    closeLabel: (0, _addonKnobs.text)('Close label', 'End Tour'),
    prevLabel: (0, _addonKnobs.text)('Prev label', 'Back'),
    hideClose: (0, _addonKnobs.boolean)('Hide "close" button', true),
    hidePrev: (0, _addonKnobs.boolean)('Hide "previous" button', true),
    hideNext: (0, _addonKnobs.boolean)('Hide "next" button', false),
    hideCheckbox: (0, _addonKnobs.boolean)('Hide checkbox', true),
    checkboxLabel: (0, _addonKnobs.text)('Checkbox label', undefined)
  }));
}).add('with flip', function () {
  return _react.default.createElement(_TourTooltip.default, _extends({}, props.default(), {
    enableFlip: true,
    flippedTitle: 'Secondary Title',
    flippedDescription: "It is an ancient Mariner,\n          And he stoppeth one of three.\n          'By thy long grey beard and glittering eye,\n          Now wherefore stopp'st thou me? ",
    nextLabel: 'Next Page',
    closeLabel: 'End Tour',
    prevLabel: 'Back'
  }));
});